#include <stdio.h>
/* Deklaration der globalen Variablen */
int zahlone, zahltwo;

/* Deklaration der Funktionen */
/* Startmen des Programms; Enscheidung zwischen Berechnung oder Ende */
int auswahl(void);

/* Verzweigung zu den Funktionen fr die Berechnung */
void berechnen(int);

/* Men zur Auswahl der Berechnungsart am Bildschirm ausgeben */
int rechart(void);

/* Ausgabe des Ergebnis der Berechnung */
void ausgabe(int, char);

/* Funktionen fr die einzelnen Berechnungsarten */
int addition(void);
int subtraktion(void);
int multiplikation(void);
int division(void);

int main(){
     int wahl; 
     wahl = auswahl(); 
     
     /* Wenn der Benutzer nicht Beenden des Programms gewhlt hat */
     if (wahl != 0){
         berechnen(wahl);
     } 
     return 0;	
}

int auswahl(void){
     int wahl, choice;
     printf("\n 1 = Zwei Zahlen fuer eine Berechnung eingeben.");
     printf("\n 0 = Programm beenden");
     printf("\n Eingabe:");
     scanf("%i", &wahl);
     
     if (wahl == 1){
         /* Auswahl der Berechnungsart */   
         choice = rechart();
         /* Zurck zum Startbildschirm */
         if (choice == 0)choice = auswahl();
         else return(choice); 
     }
          
     return(0);  
          
}

int rechart(void){
     int wahl;
     printf("\n Bitte geben Sie die erste Zahl fuer die Berechnung ein:");
     scanf("%i", &zahlone);
     printf("\n Bitte geben Sie die zweite Zahl fuer die Berechnung ein:");
     scanf("%i", &zahltwo);
     printf("\n Waehlen Sie die Berechnungsart:");
     printf("\n 1 = Addition");
     printf("\n 2 = Subtraktion");
     printf("\n 3 = Multiplikation");
     printf("\n 4 = Division; Ergebnis wird als ganze Zahl ausgegeben.");
     printf("\n 0 = zur Anfangsmaske");
     printf("\n Eingabe:");
     scanf("%i", &wahl);
     return(wahl);
}

void berechnen(int art){
        int summe, zeich;
        
        /* Verzweigung zu den einzelnen Berechnungsfunktionen und
        Erstellen des Zeichens fr die Ausgabe */
        switch(art){
            case 1: summe = addition();
                    zeich = '+';
                    break;
            case 2: summe = subtraktion();
                    zeich = '-';
                    break; 
            case 3: summe = multiplikation();
                    zeich = '*';
                    break;
            case 4: summe = division();
                    zeich = '/';
                    break;
         }
         
         ausgabe(summe, zeich);

}

void ausgabe(int ergebnis, char art){
     int wahl, choice;
      
     printf("\n");
     printf("%10i \n", zahlone);
     printf("%c %8i \n", art, zahltwo);
     printf("---------- \n");
     printf("%10i \n", ergebnis);
     printf("\n");
     printf("\n 1 = Moechten Sie weitere Berechnungen ausfuehren oder");
     printf("\n 0 = das Programm beenden");
     printf("\n Eingabe:");
     scanf("%i", &wahl);
     
     /* weitere Berechnungen */
     if (wahl == 1){
         choice = rechart();
         berechnen(choice); 
     }
}

int addition(void){
    int rechnen;
    rechnen = zahlone + zahltwo;
    return(rechnen);  
}

int subtraktion(void){
    int rechnen;
    rechnen = zahlone - zahltwo;
    return(rechnen);  
}

int multiplikation(void){
    int rechnen;
    rechnen = zahlone * zahltwo;
    return(rechnen);  
}

int division(void){
    int rechnen;
    
    /* Division durch Null */
    if (zahltwo == 0){
        printf("Eine Division durch Null ist nicht mglich.");
        return(0);  
    }   
    /* Der Divisor ist grer als der Divident */ 
    else if (zahltwo > zahlone){
        printf("Der Qoutient ergibt Null bei einer ganzzahligen Division \n");
        printf("da der Divisor grer ist als der Dividend ist. \n");
        return(0); 
    } 
    else{
         rechnen = zahlone / zahltwo;
         return(rechnen); 
    }     
     
}


